﻿using System;
using System.Linq;
using System.Drawing;
using System.Drawing.Drawing2D;

public partial class GDIResize : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		Bitmap originalImage = new Bitmap("C:\\dt7odrjbc.gif");
		Image img = (Image)originalImage;

		string sFullPath = Server.MapPath("~/Uploads/");
		string sFileName = "testImage" + DateTime.Now.Ticks;
		string sExt = ".gif";
		string sThumbName = sFileName + "_thumb";

		if (img.Width > 600 && img.Height > 600)
			img = Resize(img, new Size(600, 600), InterpolationMode.Bicubic);
		img.Save(sFullPath + sFileName + sExt);

		if (img.Width > 150 && img.Height > 150)
			img = Resize(img, new Size(150, 150), InterpolationMode.Bicubic);
		img.Save(sFullPath + sThumbName + sExt);
	}

	public virtual Image Resize(Image originalImg, Size newSize, InterpolationMode intMode)
	{
		int width = newSize.Width, height = newSize.Height;
		if (width > 0 && height > 0 && (originalImg.Width != width || originalImg.Height != height))
		{
			//Bitmap bmImage = new Bitmap(width, height, PixelFormat.Format32bppPArgb);
			var bmImage = new Bitmap(width, height);
			using (Graphics grImage = Graphics.FromImage(bmImage))
			{
				grImage.SmoothingMode = SmoothingMode.AntiAlias;
				grImage.InterpolationMode = intMode;
				grImage.PixelOffsetMode = PixelOffsetMode.HighQuality;
				if (intMode != InterpolationMode.NearestNeighbor)
				{
					var rect = new RectangleF(-0.5f, -0.5f, (float)(newSize.Width + 1), (float)(newSize.Height + 1));
					grImage.DrawImage(originalImg, rect);
				}
				else
				{
					grImage.DrawImage(originalImg, new Rectangle(new Point(0, 0), newSize), new Rectangle(new Point(0, 0), originalImg.Size), GraphicsUnit.Pixel);
				}
				originalImg = bmImage;
			}
			return bmImage;
		}

		return new Bitmap(originalImg);
	}
}